module Filch
  # Ransack for results, and then manipulate data as necessary.
  class RansackPlus
    def initialize(model, params)
      @params = params
      @params[:limit] = limit_fix(params[:limit]) if @params
      @q = model.ransack(@params)
      @result = ransack_result
    end
    attr_reader :q, :result

    # get the results!
    def ransack_result
      return [] unless @params
      @q.result
    end

    # adjust the limit for certain scenarios.
    # ransack doesn't return a list if limit is 1 so change to 2.
    # also, default to 50 if limit is not set.
    def limit_fix(limit = 50)
      case limit
      when '0'
        @params.delete(:limit)
      when '1'
        '2'
      when ''
        '50'
      else
        limit
      end
    end
  end
end
